<?php

// we need some helper functions before we include prolog.php
include "helpers.php";

// get the config
//basic
$resolution=array("VGA","ED","HD");
$resolutionAdv=array();
$default_mon_ar=array("4:3","16:9","16:10");
$fixed_mon_ar=array("","hdmi","vesa","gtf","vesa,gtf","hdmi,gtf","hdmi,vesa");
$default_force_vfreq=array("","24","25","30","50","60");
$power_mode_vga=array("auto" => "Automatic","on"=>"Always On","off"=>"Always Off");
$fileName="/etc/default/vidmode";

// NOTE: the video modes for basic settings are all at 60 Hz. This
// is because LCDs work at 60 Hz natively and using 50 Hz modes
// creates funny effects because of the frame rate conversion on the
// display, in particular for 30 fps video.
$presets=array('t0' => 'TV Screen',
	       'ed' => array("hdmi","720x480","60","16:9","ED","480p"),
	       'hd' => array("hdmi","1280x720","60","16:9","HD","720p"),
	       't1' => 'Computer Monitor',
	       'vga' => array("vesa","VGA","60","4:3","VGA","640x480"),
	       'svga' => array("vesa","800x600","60","4:3","SVGA","800x600"),
	       'xga' => array("vesa","1024x768","60","4:3","XGA","1024x768"),
	       't2' => 'Wide Computer Monitor',
	       'wvga' => array("vesa,gtf","768x480","60","16:10","WVGA","768x480"),
	       'wsvga' => array("vesa,gtf","1024x640","60","16:10","WSVGA","1024x640")
     );
			   
$vidmod=file_get_contents("/etc/vid.modes");
$vidmodArray=split("\n",$vidmod);
$vidmod=file_get_contents(sysfs_vout_device() . "vid_modedb");
$vidmodArray=array_merge($vidmodArray,split("\n",$vidmod));

foreach ($vidmodArray as $str){
	if (preg_match("/=\s*(.*)/",$str,$match)){
		$values=split(" ",$match[1]);
		if (count($values)>=12){
			if ($values[10]=='p' && !in_array($values[0]."x".$values[1], $resolutionAdv)){
				$resolutionAdv[]=$values[0]."x".$values[1];	
			}
		}	
	}
}
natsort($resolutionAdv);
reset($resolutionAdv);
$resolutionAdv=array_merge($resolution,$resolutionAdv);

$setup=array();
$strings=array("RESOLUTION","FORCE_VFREQ","FORCE_AR","USE_FIXED_MODEDB","DEFAULT_MON_AR", "FIXED_MODE_TYPES", "HDMI_UNDERSCAN_IGNORE", "POWER_MODE_VGA", "CUSTOMMODE");
$orientations=array("Horizontal"=>"horizontal","Rotate 90 Right"=>"rotateRight","Rotate 90 Left"=>"rotateLeft","Rotate 180"=>"rotate180","Flip Vertical"=>"flipVert","Flip Horizontal"=>"flipHor");

class TSConfig {
     public $xx = 1;
     public $xy = 0;
     public $yx = 0;
     public $yy = 1;
     public $tx = 0;
     public $ty = 0;
     private static $attrs = array("xx", "xy", "yx", "yy", "tx", "ty");
     function reset() {
	  $this->xx = 1;
	  $this->xy = 0;
	  $this->yx = 0;
	  $this->yy = 1;
	  $this->tx = 0;
	  $this->ty = 0;
     }
     function isidentity() {
	  return ($this->xx == 1 && $this->xy == 0 &&
		  $this->yx == 0 && $this->yy == 1 &&
		  $this->tx == 0 && $this->ty == 0);
     }
     function load(&$domdoc) {
	  $ts = $domdoc->getElementsByTagName("tscalibration");
	  if ($ts->length >= 1) {
	       $ts=$ts->item($ts->length-1); // we default to using the last one
	       foreach (self::$attrs as $a) {
		    if ($ts->hasAttribute($a) && is_numeric($ts->getAttribute($a)))
			 $this->$a = $ts->getAttribute($a);
	       }
	  }
     }
     function set(&$domdoc) {
	  $modified = false;
	  $valid = true;
	  
	  if (isset($_POST['resetts']) || isset($_POST['applyts'])) {
	  	// we allways leave the calibration mode when the user press the button
	  	// even if the data are not changed or not valid
		  $tempAnim = $domdoc->getElementById("tscalibration_anim"); 
		  if ( $tempAnim && ! isset($_POST['calibration'])) {
		  	$tempAnim->parentNode->removeChild($tempAnim);
		  }
	  }
	  // NOTE: even if not valid we still update the data
	  // so that the form always returns what the user entered
	  if (isset($_POST['resetts'])) {
		   if ( $this->isidentity() )
			return false; // OK, nothing to change
		   $this->reset();
		   $modified = true;
	  }
	  if (isset($_POST['applyts'])) {
	       foreach (self::$attrs as $a) {
		    $n = 'ts_' . $a;
		    $v = '';
		    if ( ! isset($_POST[$n]) ) {
			 echo "<p style='color:red'>Error: missing '",
			      htmlspecialchars($n),
			      "' value; touchscreen data not saved</p>\n";
			 $valid = false;
		    } else {
			 $v = trim($_POST[$n]);
			 if ( $v == '' || ! is_numeric($v) ) {
			      echo "<p style='color:red'>Error: invalid value '",
				   htmlspecialchars($v), "' for '", htmlspecialchars($a),
				   "'; touchscreen data not saved</p>\n";
			      $valid = false;
			 }
		    }
		    if ($v != $this->$a) {
			 $this->$a = $v;
			 $modified = true;
		    }
	       }
	  }
	  
	  if ( ! $modified || ! $valid )
	       return false;
	  $ts = $domdoc->getElementsByTagName("tscalibration");
	  if ($ts->length >= 1) {
	       $ts=$ts->item($ts->length-1); // we default to using the last one
	  } else {
	       $player = $domdoc->getElementsByTagName("player");
	       if ($player->length!=1) {
		    echo "<p style='color:red'>Error: corrupted configuration file; ",
			 "touchscreen data not saved</p>\n";
		    return false;
	       }
	       $player = $player->item(0);
	       $ts = $domdoc->createElement("tscalibration");
	       $player->appendChild($ts);
	  }
	  foreach (self::$attrs as $a) {
	       $ts->setAttribute($a, $this->$a);
	  }
	  
	  return true;
     }
}

$ts = new TSConfig;

$reboot=false;

$showAdvanced=false;
$showBasic=false;
$apply=false;
$check=false;
$cancel=false;
$hasTempFile=false;
$disable="";
foreach ($_POST as $name=>$val){
	if (in_array($name, $strings)){
		$setup[$name]=$val;
	}
	if ($name=='showAdvanced')
		$showAdvanced=true;
	if ($name=='showBasic')
		$showBasic=true;
	if ($name=='apply')
		$apply=true;
	if ($name=='applyadv'){
		$apply=true;
		$hasTempFile=true;
		$showAdvanced=true;
	}
	if ($name=='check'){
		$check=true;
		$showAdvanced=true;
	}
	if ($name=='cancel'){
		$cancel=true;
		$showAdvanced=true;
		$hasTempFile=true;
	}
}



if ($hasTempFile){
	$config=file_get_contents($fileName.".tmp");
	foreach ($strings as $name){
	     if ($count = preg_match_all("/^\s*$name=(.*)/m",$config,$matches, PREG_SET_ORDER)){
			$setup[$name]=$matches[$count-1][1];
	     }else
			$setup[$name]="";
		if ($name=='CUSTOMMODE' && $setup[$name]!="" ) $setup[$name]=substr($setup[$name],1,-1); // remove the ""
	}
	unlink($fileName.".tmp");
}

$config=file_get_contents($fileName);

if (isset($_GET['tabs'])){
	if ($_GET['tabs']==1) $showBasic=true;
	else $showAdvanced=true;
} 
if (isset($_POST['tabs'])){
	if ($_POST['tabs']==1) $showBasic=true;
	else $showAdvanced=true;
}

$defaultAspectRatio="4:3";
if (isset($_POST['screen']) && isset($presets[$_POST['screen']])){
	$setup["USE_FIXED_MODEDB"]='yes';
	$setup["HDMI_UNDERSCAN_IGNORE"]='';
	$setup["FORCE_VFREQ"]=$presets[$_POST['screen']][2];
	$setup["FORCE_AR"]='';
	$setup["CUSTOMMODE"]='';
	$setup["FIXED_MODE_TYPES"]=$presets[$_POST['screen']][0];
	$setup["RESOLUTION"]=$presets[$_POST['screen']][1];
	
	if (!isset($_POST['forceAR']) || !$_POST['forceAR'])
		$setup["DEFAULT_MON_AR"]=$presets[$_POST['screen']][3];
	$defaultAspectRatio=$presets[$_POST['screen']][3];;
}
$vga=$svga=$xga=$wvga=$wsvga=$ed=$hd="";

foreach ($strings as $string) {
	if (!isset($setup[$string])) $setup[$string]="";
}

// we need to output the configurator version for the upgrade script
$setup['CONFIGURATOR_VERSION']='2';
// apply the changes
$save=false;
$badvidsetup=array();
foreach ($setup as $name => $val){
	$found=false;
	if (has_shell_metachars($name) || has_shell_metachars($val)) {
	     $badvidsetup[$name] = $val;
	}
	if (count($badvidsetup)) {
	     // bad config detected just verify all arguments, skip all editing
	     continue;
	}
	if ($name=='CUSTOMMODE' && $val!="" )
		$val = "\"$val\"";
	if ($count = preg_match_all("/^\s*$name=(.*)/m",$config,$matches, PREG_SET_ORDER)) {
		$previous=$matches[$count-1][1];
		$found=true;	
	} else if (preg_match("/^\s*#+$name=/m",$config)) {
		$previous="";
		$found=true;	
	} else {
		$previous="";
	}
	if ($previous!=$val && ($apply || $check)){
		if ($found) {
			if ($val=="")
				$config=preg_replace("/^\s*#*$name=.*/m","#$name=",$config);
			else
				$config=preg_replace("/^\s*#*$name=.*/m","$name=$val",$config);
		}else {
			if ($val=="")
				$config.="\n#$name=$val\n";
			else
				$config.="\n$name=$val\n";
		}
		$save=true;
	}else if (!$cancel) {
		if ( $name=='CUSTOMMODE' ) $setup[$name]=substr($previous,1,-1);
		else $setup[$name]=$previous;;
	}
}


//foreach ($setup as $name=>$val) echo "$name => $val<br/>";
$found=false;

if ($setup["USE_FIXED_MODEDB"]=='yes' && $setup["HDMI_UNDERSCAN_IGNORE"]=='' && $setup["FORCE_AR"]=='' && $setup["CUSTOMMODE"]==''){
	foreach ($presets as $id => $val){
		if (is_array($values) && $setup["FIXED_MODE_TYPES"]==$val[0] && $setup["RESOLUTION"]==$val[1] && $setup["FORCE_VFREQ"]==$val[2]){
			$$id="checked='checked'";
			$selectedId=$id;
			$showBasic=!$showAdvanced;
			$found=true;
		}
	}
	
}

if (!$found)
	$showAdvanced=!$showBasic;

if ($showBasic) $tabIdx=1;
else $tabIdx=2;
$tabs=array("Basic","Advanced");
$title="Display Settings"; 
include ("prolog.php");

if (count($badvidsetup)) {
     echo "<p style='color:red'>Error: the following errors where encountered, ",
	  "request ignored.<br/>\n";
     foreach ($badvidsetup as $name => $val) {
	  echo "Parameter '",
	       htmlspecialchars($name), "' with value '", htmlspecialchars($val),
	       "' is not valid.<br/>\n";
     }
     echo "</p>\n";
}

//Splash screens
$logo_files="/etc/default/splash";
if (isset($_POST['resetLogo'])){
	file_put_contents($logo_files,file_get_contents($logo_files.".spxsave"));
}
$logoconf=file_get_contents($logo_files);
$fileslists=array("BOOTIMG"=>"/etc/spinetix/splash/splash", "SHUTDOWNIMG"=>"/etc/spinetix/splash/shutdown", "FIRMUPDIMG"=>"/etc/spinetix/splash/fimrware-upd");
foreach ($fileslists as $fn=>$dstfn ){
	if (preg_match("/^\s*$fn=(.*)/m",$logoconf,$match)==1){
		$tmp = $match[1];
		
		if (dirname($tmp)=="/usr/share/resources/default/splash") $source="default";
		else $source="user";
		$file = basename($tmp);
		${$fn}="name=$file&amp;source=$source";
	}
}

$mustSave=false;

if (isset($_POST['applyLogo'])){
	
	foreach ($fileslists as $fn=>$dstfn){
 	if (array_key_exists($fn,$_FILES) && $_FILES[$fn]["name"]!=""){
 		
 		$allOk=true;
 		$dstName="";
		if ($_FILES[$fn]["error"]>0 && $_FILES[$fn]["name"]){
		     echo "Error: ", htmlspecialchars($_FILES[$fn]["error"]), " while uploading: ", htmlspecialchars($_FILES[$fn]["name"]), "<br />";
		     $allOk=false;
		} else {
			if ($_FILES[$fn]["size"]>1024*1024){
				echo "Error: ", htmlspecialchars($_FILES[$fn]["name"]), " is larger than the maximum fiel size of 1MB<br />";
				$allOk=false;
			} else {
				$ext=pathinfo($_FILES[$fn]["name"]);
				if ($_FILES[$fn]["type"]=='image/jpg' || strcasecmp("jpg",$ext["extension"])==0 || strcasecmp("jpeg",$ext["extension"])==0){
					$dstName = $dstfn.".jpg";
				} else if ($_FILES[$fn]["type"]=='image/png' || strcasecmp("png",$ext["extension"])==0 ){
					$dstName = $dstfn.".png";
				}else{
				     echo "Error: ", htmlspecialchars($_FILES[$fn]["name"]), " is not a JPEG of PNG file<br />";
				     $allOk=false;
				}
			}
		}
		if ( $allOk ) {
			move_uploaded_file($_FILES[$fn]["tmp_name"],$dstName);
			$logoconf = preg_replace("/$fn=.*/","$fn=$dstName",$logoconf);
			$mustSave=true;
			$file=basename($dstName);
			${$fn}="name=$file&amp;source=user";
		}
 	}
	}	
 	if ($mustSave){
 		file_put_contents($logo_files,$logoconf);
 	}
	
}

$scanpercent=3;
$orientation=$orientations['Horizontal'];

$config_name="/srv/raperca/spxconfig.xml";
$scanconf=file_get_contents($config_name);
$enableAudio=1;
$saveConf=false;
$maxLatency=1.500;
$interactLatency=0.060;
$allowEvents=false;
$calibation=false;

$comport = new ComPort;

if ($scanconf) {
	$domdoc = new DOMDocument;
	$domdoc->loadXML($scanconf);
	$svglib=$domdoc->getElementsByTagName("svglib");
	if ($svglib->length==1){
		$svglib=$svglib->item(0);
		if ($svglib->hasAttribute("mute")) $enableAudio=$svglib->getAttribute("mute")=='off';
	}else unset($svglib);
	if ( (isset($_POST['apply']) || isset($_POST['applyadv']) || isset($_POST['check']) ) && isset($svglib)){
		$enableAudio=isset($_POST['enableAudio']);
		if ($enableAudio) $svglib->setAttribute("mute", 'off');
		else $svglib->setAttribute("mute", 'on');
		$saveConf=(isset($_POST['apply']) || isset($_POST['applyadv']));
	}
	
	$svgrender=$domdoc->getElementsByTagName("svgrender");
	if ($svgrender->length==1){
		$svgrender=$svgrender->item(0);
		if ($svgrender->hasAttribute("overScanMargin")) $scanpercent=$svgrender->getAttribute("overScanMargin");
		if ($svgrender->hasAttribute("screenOrientation")) $orientation=$svgrender->getAttribute("screenOrientation");
		if ($svgrender->hasAttribute("maxLatency")) $maxLatency=$svgrender->getAttribute("maxLatency");
		if ($svgrender->hasAttribute("interactLatency")) $interactLatency=$svgrender->getAttribute("interactLatency");
	}else unset($svgrender);
	
	$interactivity=$domdoc->getElementsByTagName("interactivity");
	if ($interactivity->length==1){
		$interactivity=$interactivity->item(0);
		if ($interactivity->hasAttribute("allowEvents")) $allowEvents=$interactivity->getAttribute("allowEvents");
	}else unset($interactivity);
	
	if (isset($_POST['applyinter'])){
		$player = $domdoc->getElementsByTagName("player");
		if ($player->length==0){
			$player = $domdoc->createElement("player");
			$domdoc->documentElement->appendChild($player);
		} else $player=$player->item(0);
		if (!isset($interactivity)){
			$interactivity = $domdoc->createElement("interactivity");
			$player->appendChild($interactivity);
		}
		$oldevents=$allowEvents;
		if (isset($_POST['allowEvents']))
			$allowEvents = $_POST['allowEvents'];
		else
			$allowEvents = 'off';
		if ($oldevents!=$allowEvents)
			$reboot=true;
		$interactivity->setAttribute("allowEvents", $allowEvents);

		if (!isset($svgrender)){
			$svgrender = $domdoc->createElement("svgrender");
			$player->appendChild($svgrender);
		}
		$maxLatency = $_POST['latency'];
		if (isset($_POST['dynlatency'])){
			$interactLatency=0.060;
		}else{
			$interactLatency=1.500;
		}
		$svgrender->setAttribute("maxLatency", $maxLatency);
		$svgrender->setAttribute("interactLatency", $interactLatency);
		
		$saveConf=true;

	}
	if ( ( isset($_POST['overscan']) || isset($_POST['orientation']) || isset($_POST['displayOrientation']) ) && !isset($svgrender)){
		echo "Cannot set the overscan margin or screen orientation<br/>";
	}else{
		
		if (isset($_POST['overscan'])){
			$scanpercent=$_POST['overscan'];
			$svgrender->setAttribute("overScanMargin", $scanpercent);
			$saveConf=(isset($_POST['apply']) || isset($_POST['applyadv']));
		}
		if (isset($_POST['orientation'])){
			$orientation=$_POST['orientation'];
			$svgrender->setAttribute("screenOrientation", $orientation);
			$saveConf=(isset($_POST['apply']) || isset($_POST['applyadv']));
		}
	}
	if ( isset($_POST['calibrateOn']) ) {
		$sources = $domdoc->getElementsByTagName("sources");
		if ($sources->length>0){
			$sources=$sources->item(0);
			$anim = $domdoc->createElementNs("http://www.w3.org/2000/svg", "animation");
			$anim->setAttribute("xml:id", "tscalibration_anim");
			$anim->setAttribute("priority", "10");
			$anim->setAttribute("type", "image/svg+xml");
			$anim->setAttribute("xlink:href", "/srv/raperca/admin/calibration.svg");
			$sources->appendChild($anim);
			$saveConf = true;
		}
	}
	if ( isset($_POST['calibrateOff']) ) {
		
	  	$tempAnim = $domdoc->getElementById("tscalibration_anim"); 
	  	if ( $tempAnim ) {
	  		$tempAnim->parentNode->removeChild($tempAnim);
	  	}
	  	$saveConf = true;
	}
	
	
	$comport->load( $domdoc );
	if ( isset($_POST['applyPowerSave']) ) {
		if ( $comport->set( $_POST ) ) {
			$comport->save( $domdoc );
			$saveConf = true;
			$reboot = true;
		}
	}

	$ts->load($domdoc);
	$modified = $ts->set($domdoc);
	if ($modified)
	     $saveConf = true;
	     
	if ( $domdoc->getElementById("tscalibration_anim") && $domdoc->getElementById("tscalibration_anim")->parentNode ) {
		$showAdvanced = true;
		$calibation=true;
		echo "<h2 class='red'>Touchscreen Calibration in process</h2>";
		echo "<p>Please follow the instruction on the screen attached to the $product or press the 'Stop calibration procedure' button.</p>";
	}
}


if ($check && ! count($badvidsetup)){
	save_file($fileName.".tmp",$config);
	$output=array();
	exec("/etc/init.d/vidmode probe ".$fileName.".tmp", $output);
	
	if (trim($output[0])=="Probing video mode OK"){
		$sets=explode ("=",$output[1]);
		$vals=explode (" ",trim($sets[count($sets)-1]));
		echo "<h2>Selected Display Settings: </h2>\n<table>\n";
		if ($vals[11]=="0:0") $vals[11]="[auto]";
		if ($vals[11]=="x:x") $vals[11]="[unknown]";
		print ("<tr><td>Resolution : </td><td>".htmlspecialchars($vals[0])."x".htmlspecialchars($vals[1])."</td></tr>\n");
		print ("<tr><td>Vertical refresh : </td><td>".htmlspecialchars($vals[2])." Hz</td></tr>\n");
		print ("<tr><td>Aspect Ratio : </td><td>".htmlspecialchars($vals[11])."</td></tr>\n");
		echo "</table>\n";
	}else{
		echo "<h2>Selected Display Settings: </h2>\n";
		echo "The selected settings do not result in a video mode supported by the $product<br/>\n";
		echo "Please change your settings, or use the Basic configuration interface.<br/><br/>\n";
		$check=false;
	}
}else if ($save && ! count($badvidsetup))
	$reboot=save_file($fileName,$config);
if ($check)
	$disable="disabled='disabled'";


if ( $saveConf ){
	save_file($config_name,$domdoc->saveXML());
	if ( ! $reboot )
	     reconfig_player();
}

if ($reboot){
	shutdown("display config change");
}else{

if (!$showAdvanced){
?>
<script type="text/javascript">
<!--
<?php
echo "var defaultAR=\"$defaultAspectRatio\";\n";
?>


function forceAspect()
{
	var selectAr=document.getElementById("ARSelect");
	var checkAr=document.getElementById("ForceARCheck");
	selectAr.disabled=!checkAr.checked;
	updateAR(defaultAR, false);
}
function updateImage()
{
	var dirNames=new Array("", "_90CW", "_90CCW", "_180", "_V", "_H");
	var arNames=new Array("4_3", "16_9", "16_10");
	var arNames2=new Array("4:3", "16:9", "16:10");
	var selectOrientation=document.getElementById("DirSelect");
	var selectAR=document.getElementById("ARSelect");
	var imgAr=document.getElementById("ScreenImg");
	
	imgAr.alt="Screen "+ arNames2[selectAR.selectedIndex];
	
	imgAr.src="images/screen_"+ arNames[selectAR.selectedIndex] + dirNames[selectOrientation.selectedIndex] + ".png";
	
	/*
	if (selectOrientation.selectedIndex==1 || selectOrientation.selectedIndex==2 ){
		imgAr.width="";
		imgAr.height=170;
	}else{
		imgAr.width=170;
		imgAr.height="";
	}
	*/
	
}
function updateAR(strAspectRatio, boolForce)
{
	
	var checkAr=document.getElementById("ForceARCheck");
	var selectAr=document.getElementById("ARSelect");
	
	if (boolForce){
		checkAr.checked=false;
		selectAr.disabled=true;
	}
	
	var x=selectAr.selectedIndex;
	if (strAspectRatio=="") {
		if (selectAr.selectedIndex==0){
			strAspectRatio="4:3";
		} else if (selectAr.selectedIndex==1){
			strAspectRatio="16:9";
		} else {
			strAspectRatio="16:10";
		}
	} else {
		defaultAR=strAspectRatio;	
	}
	if (!checkAr.checked){
		if (strAspectRatio=="4:3"){
			selectAr.selectedIndex=0;
		} else if (strAspectRatio=="16:9"){
			selectAr.selectedIndex=1;
		} else if (strAspectRatio=="16:10"){
			selectAr.selectedIndex=2;
		}
	}
	updateImage();
	
	
}

function enableMonPower()
{
	var iPowerSave=document.getElementById("PowerSaveId");
	var iControlMonPower=document.getElementById("ControlMonPower");
	var iControlMonPower2=document.getElementById("ControlMonPower2");
	
	iControlMonPower.disabled = !iPowerSave.checked;
	iControlMonPower2.disabled = !iPowerSave.checked;
	document.getElementsByName("onTime")[0].disabled=(!iPowerSave.checked || !iControlMonPower.checked);
	document.getElementsByName("offTime")[0].disabled=(!iPowerSave.checked || !iControlMonPower.checked);
}
-->
</script>
<h2>Display Settings: </h2>

<form action="displayconfig.php" method="post">
<table>

<?php
echo "<tr><td/><td/><td rowspan='11' valign='middle' align='center' width='360'>\n";
	
$postfixNames=array("horizontal" => "", "rotateRight" => "_90CW", "rotateLeft" => "_90CCW", "rotate180" => "_180", "flipVert" => "_V", "flipHor" => "_H");
$orientation;
$postfix=$postfixNames[$orientation];
if ($setup['DEFAULT_MON_AR']=='4:3')
	echo "<img id='ScreenImg' src='images/screen_4_3$postfix.png' alt='Screen 4:3' />\n";
elseif ($setup['DEFAULT_MON_AR']=='16:10')
	echo "<img id='ScreenImg' src='images/screen_16_10$postfix.png' alt='Screen 16:10' />\n";
else
	echo "<img id='ScreenImg' src='images/screen_16_9$postfix.png' alt='Screen 16:9' />\n";

echo "<br/>";
$disabledAr="";
if (isset($selectedId) && $presets[$selectedId][3]!=$setup['DEFAULT_MON_AR']){
	print ("<input type='checkbox' id='ForceARCheck' onclick='forceAspect()' name='forceAR' checked='checked' />\n");
}else{
	print ("<input type='checkbox' id='ForceARCheck' onclick='forceAspect()' name='forceAR' />\n");
	$disabledAr="disabled='disabled' ";
}
print("Force aspect ratio to: ");
	
print ("<select id='ARSelect' name='DEFAULT_MON_AR'  onchange='updateAR(\"\",false)' $disabledAr>\n");
foreach($default_mon_ar as $name)
	if ($setup['DEFAULT_MON_AR']==$name )
		print("<option value='$name' selected='selected'>$name</option>\n");
	else
		print("<option value='$name'>$name</option>\n");
print("</select>\n<br/><br/>\n");

print("Screen orientation: <select name='orientation' id='DirSelect' onchange='updateImage()'>\n");
foreach($orientations as $name => $val)
	if ($orientation==$val)
	     print("<option value='$val' selected='selected'>". htmlspecialchars($name). "</option>\n");
	else
	     print("<option value='$val'>". htmlspecialchars($name). "</option>\n");
print("</select><br/>\n"); 

echo "</td></tr>";

foreach ($presets as $id => $values){
	if (is_array($values)){
	     print "<tr><td><input type='radio' name='screen' onclick='updateAR(\"".$values[3]."\", true)' value='$id' ".$$id." /> ". htmlspecialchars($values[4]). " </td><td>". htmlspecialchars($values[5]). "</td></tr>\n";
	}else{
	     print "<tr><td colspan='2'><h3>". htmlspecialchars($values). "</h3></td></tr>\n";
	}
}
print "<tr><td colspan='2' valign='bottom'>";

if ($enableAudio)
	print ("<input type='checkbox' name='enableAudio' checked='checked' />&nbsp;&nbsp;Enable audio output\n");
else
	print ("<input type='checkbox' name='enableAudio' />&nbsp;&nbsp;Enable audio output\n");

print "</td><td valign='bottom' align='center'>";

print("Overscan percentage <select name='overscan' >\n");
for ($i=0; $i<6; $i ++)
	if ($i==$scanpercent) print("<option value='$i' selected='selected'>$i</option>\n");
	else print("<option value='$i'>$i</option>\n");
print("</select><br/><br/>\n"); 


print("Power mode for VGA output&nbsp;&nbsp;<select name='POWER_MODE_VGA' $disable>\n");
foreach($power_mode_vga as $name => $val)
	if ($setup['POWER_MODE_VGA']==$name )
		print("<option value='$name' selected='selected'>$val</option>\n");
	else
		print("<option value='$name'>$val</option>\n");
print("</select><br/>\n");
	
print "</td></tr>\n";

print "</table>\n";

echo "<input type='submit' value='Apply' name='apply'/></form><br/>\n";

print "<h2>Display Power Save:</h2>\n";

print "<form action='displayconfig.php' method='post'>\n";
print "<table>\n";
print "<tr><td>\n";
print "<input type='hidden' name='powerSave' value='false' />";
print "<input type='checkbox' id='PowerSaveId' onclick='enableMonPower()' name='powerSave' value='true' ".($comport->powerSave=='true'?"checked='checked' ":"")."/>";
print "</td><td colspan='3'>Enable display power saving</td></tr>\n";
print "<tr><td/><td>\n";
$monEnabled="";
if ( $comport->powerSave!="true" )
	$monEnabled="disabled='disabled' ";
print "<input type='hidden' id='ControlMonPower2' name='monPower' value='false' $monEnabled />";
print "<input type='checkbox' id='ControlMonPower' onclick='enableMonPower()' value='true' name='monPower' $monEnabled ";
if ( $comport->monPower=="true" ){
	$enableMonPower=$comport->powerSave=="true"?"":"disabled='disabled' ";
	print "checked='checked' />";
}else{
	print "/>";
	$enableMonPower="disabled='disabled' ";
}
print "</td><td colspan='2' >Use fixed schedule for display power</td></tr>\n"; 
print "<tr><td/><td/><td>Turn monitor ON</td><td><input size='8' type='text' name='onTime' value=\"". htmlspecialchars($comport->onTime) ."\" $enableMonPower/></td></tr>\n";
print "<tr><td/><td/><td>Turn monitor OFF</td><td><input size='8' type='text' name='offTime' value=\"". htmlspecialchars($comport->offTime). "\" $enableMonPower/></td></tr>\n";

print "</table>\n";
echo "<input type='submit' value='Apply' name='applyPowerSave'/></form>\n";

}
if ($showAdvanced){
?>
<h2>Display Settings: </h2>
<form action="displayconfig.php" method="post">
<table>
<?php

print("<tr><td> Resolution </td><td><select id='Resolution' name='RESOLUTION' $disable>\n");
foreach($resolutionAdv as $name)
	if ($setup['RESOLUTION']==$name )
		print("<option value='$name' selected='selected'>$name</option>\n");
	else
		print("<option value='$name'>$name</option>\n");
print ("</select></td></tr>\n");

print("<tr><td>Default aspect ratio </td><td><select name='DEFAULT_MON_AR' $disable>\n");
foreach($default_mon_ar as $name)
	if ($setup['DEFAULT_MON_AR']==$name )
		print("<option value='$name' selected='selected'>$name</option>\n");
	else
		print("<option value='$name'>$name</option>\n");
	
print("</select></td></tr>\n"); 

print("<tr><td>Force standard video modes</td><td>\n<input type='checkbox' name='USE_FIXED_MODEDB' value='yes' $disable");
if ( $setup['USE_FIXED_MODEDB']=='yes' )
	print(" checked='checked' ");
print(" /></td></tr>\n");			

print("<tr><td>Restrict video mode to </td><td><select id='Restrict' name='FIXED_MODE_TYPES' $disable>\n");
foreach($fixed_mon_ar as $name)
	if ($setup['FIXED_MODE_TYPES']==$name )
		print("<option value='$name' selected='selected'>$name</option>\n");
	else
		print("<option value='$name'>$name</option>\n");
print("</select></td></tr>");

print("<tr><td>Power mode for VGA output </td><td><select name='POWER_MODE_VGA' $disable>\n");
foreach($power_mode_vga as $name => $val)
	if ($setup['POWER_MODE_VGA']==$name )
		print("<option value='$name' selected='selected'>$val</option>\n");
	else
		print("<option value='$name'>$val</option>\n");
print("</select></td></tr>");

print "<tr><td>HDMI display supports underscan</td><td><input type='checkbox' name='HDMI_UNDERSCAN_IGNORE' value='no' $disable";
if ( $setup['HDMI_UNDERSCAN_IGNORE']=='no' )
	print(" checked='checked'");
print("/></td></tr>\n");

print("<tr><td>Overscan percentage</td><td><select name='overscan' >\n");
for ($i=0; $i<6; $i ++)
	if ($i==$scanpercent) print("<option value='$i' selected='selected'>$i</option>\n");
	else print("<option value='$i'>$i</option>\n");
print("</select></td></tr>\n"); 

print("<tr><td>Force vertical refresh</td><td><select name='FORCE_VFREQ' id='ForceVFreq' $disable>\n");
foreach($default_force_vfreq as $name)
	if ($setup['FORCE_VFREQ']==$name)
		print("<option value='$name' selected='selected'>$name</option>\n");
	else
		print("<option value='$name'>$name</option>\n");
print("</select> Hz</td></tr>\n"); 

print("<tr><td>Screen orientation</td><td><select name='orientation' >\n");
foreach($orientations as $name => $val)
	if ($orientation==$val)
		print("<option value='$val' selected='selected'>$name</option>\n");
	else
		print("<option value='$val'>$name</option>\n");
print("</select></td></tr>\n"); 
if ($enableAudio)
	print ("<tr><td>Enable audio output</td><td><input type='checkbox' name='enableAudio' checked='checked' /></td></tr>\n");
else
	print ("<tr><td>Enable audio output</td><td><input type='checkbox' name='enableAudio' /></td></tr>\n");

if ($setup['CUSTOMMODE']!="" || $advancedMode )
	print("<tr><td>Custom video mode:</td></tr><tr><td colspan='2'><input type='text' size='60' id='CustomMode' name='CUSTOMMODE' onchange='updateCustomMode()' value='".$setup['CUSTOMMODE']."' $disable /></td></tr>\n");

print "</table>\n";
if ($setup['CUSTOMMODE']!="" || $advancedMode ) {
?>
<script type="text/javascript">
	function updateCustomMode() {
		var idCustomMode=document.getElementById("CustomMode");
		var idForceVFreq=document.getElementById("ForceVFreq");
		var idResolution=document.getElementById("Resolution");
		var idRestrict=document.getElementById("Restrict");
		if ( idCustomMode.value!="" ){
			idForceVFreq.disabled=true;
			idResolution.disabled=true;
			idRestrict.disabled=true;
		} else {
			idForceVFreq.disabled=false;
			idResolution.disabled=false;
			idRestrict.disabled=false;
		}
	}
	updateCustomMode();
</script>
<?php
}
if ($check){
	echo "<input type='submit' value='Apply' name='applyadv'/>";
	echo "<input type='submit' value='Cancel' name='cancel'/>";
}else
	echo "<input type='submit' value='Check' name='check'/>";
echo "</form>";

if (isset($licenses['INTER']) && $licenses['INTER']!==false) {
echo "<br/><h2>Interactivity Settings</h2>";
echo "<form action='displayconfig.php' method='post'><br/>";
echo "<input type='checkbox' name='allowEvents' value='on'";
if ($allowEvents=="on") print(" checked='checked'");
echo "/>\n";
echo "Enable events<br/><br/>\n";

$latencies=array("250ms" => 0.250, "500ms" => 0.500, "1000ms" => 1.000, "1500ms" => 1.500 );

$found=false;
print("Maximum rendering latency: <select name='latency'>\n");

foreach($latencies as $name => $value) {
	if ($maxLatency<=$value && !$found) {
		$found=true;
		print("<option value='".$value."' selected='selected'>$name</option>\n");
	} else
		print("<option value='".$value."'>$name</option>\n");
}
print("</select>\n");
 


echo "<input type='checkbox' name='dynlatency' value='yes'";
if ($interactLatency!=1.500) print(" checked='checked'");
echo "/>\n";

echo "Reduce latency to 60ms when events are received\n";

echo "<br/><br/>";
echo "<input type='submit' value='Apply' name='applyinter' />";

echo "<input type='hidden' name='tabs' value='2' />\n";
echo "</form>\n";

echo "<br/><h2>Touchscreen Calibration</h2>";
echo "<form action='displayconfig.php' method='post'><br/>";
$disabletouche="";
if ($allowEvents!="on") {
	$disabletouche=" disabled='disabled'";	
	echo "Events must be enabled (above) to use touchscreens.<br/>";
}
echo "<table>\n";
echo "<tr>\n";
echo "<td>XX = <input type='text' name='ts_xx' value='", $ts->xx, "' size='6' $disabletouche/></td>\n";
echo "<td>XY = <input type='text' name='ts_xy' value='", $ts->xy, "' size='6' $disabletouche/></td>\n";
echo "<td>TX = <input type='text' name='ts_tx' value='", $ts->tx, "' size='6' $disabletouche/></td>\n";
echo "</tr><tr>\n";
echo "<td>YX = <input type='text' name='ts_yx' value='", $ts->yx, "' size='6' $disabletouche/></td>\n";
echo "<td>YY = <input type='text' name='ts_yy' value='", $ts->yy, "' size='6' $disabletouche/></td>\n";
echo "<td>TY = <input type='text' name='ts_ty' value='", $ts->ty, "' size='6' $disabletouche/></td>\n";
echo "</tr>\n";
echo "</table>\n";
echo "<input type='submit' value='Apply' name='applyts' $disabletouche/>\n";
echo "<input type='submit' value='Reset to Default' name='resetts' $disabletouche/>\n";
echo "<input type='hidden' name='tabs' value='2' />\n";
echo "</form>\n";

echo "<form action='displayconfig.php' method='post'><br/>";
if (!$calibation){
	echo "<input type='submit' value='Start calibration procedure' name='calibrateOn' $disabletouche/>\n";
	echo "<input type='hidden' name='calibration' value='1' />\n";
	echo "<input type='hidden' name='resetts' value='Reset' />\n";
}else
	echo "<input type='submit' value='Stop calibration procedure' name='calibrateOff' />\n";

echo "<p>To calibrate your touchscreen, the $product must be connected to the touchscreen and events need to be enabled. ";
echo "Then press the above button and follow the instruction on the screen.</p>\n";
echo "<input type='hidden' name='tabs' value='2' />\n";
echo "</form>\n";

} // license interactivity

echo "<br/><h2>Splash Screen Configuration</h2>";
echo "<br/>You can upload new splash screen for the $product. Select the file(s) to be used and press Apply.";

echo "<form action='displayconfig.php' method='post' enctype='multipart/form-data'><br/>";
echo "<table>\n";
echo "<tr><td>Boot splash screen<br/><input size='40' type='file' name='BOOTIMG' /></td>\n";
echo "    <td><a href='showlogo.php?$BOOTIMG'><img src='showlogo.php?$BOOTIMG' alt='Boot logo' width='180'/></a></td></tr>\n";

echo "<tr><td>Shutdown splash screen<br/><input size='40' type='file' name='SHUTDOWNIMG' /></td>\n";
echo "    <td><a href='showlogo.php?$SHUTDOWNIMG'><img src='showlogo.php?$SHUTDOWNIMG' alt='Boot logo' width='180'/></a></td></tr>\n";

echo "<tr><td>Firmware upgrade splash screen<br/><input size='40' type='file' name='FIRMUPDIMG' /></td>\n";
echo "    <td><a href='showlogo.php?$FIRMUPDIMG'><img src='showlogo.php?$FIRMUPDIMG' alt='Boot logo' width='180'/></a></td></tr>\n";
echo "</table>\n";
echo "<p>Images should be JPEG or PNG images with a maximum size of 640x480.</p>";
echo "<input type='submit' value='Apply' name='applyLogo'/>\n";
echo "<input type='submit' value='Reset to default' name='resetLogo'/>\n";
echo "<input type='hidden' name='tabs' value='2' />\n";
echo "</form>\n";

} // advanced 
} // reboot
include ("final.php");
?>
