<?xml version='1.0'?>
<?spx max-age="60" ?>
<?php 
	$queries=explode('&',$_SERVER['QUERY_STRING']);
	foreach($queries as $val) {
		$tmp=explode('=', $val);
		if (count($tmp)>1) 
			$_GET[$tmp[0]]=$tmp[1];
	} 
	echo "<!--";
	foreach($_GET as $key => $val){
	 ${$key}=$val;
	 echo "$key = $val";
	}
	echo "-->";
?>
<?php
/*
 * Created on 12 Jun 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 * 
 * This script returns an SVG file of size $docwidth x $docheight for the requested info '$info'
 * This should be used to display information about the device. The script is called from the "reporting.phpt" script.
 * 
 * The script recived a set of global variable which corespong to the query: 
 * for instance : info.php?info=network&docwidth=540&docheight=300 ... will generate the variables $info="network"; $docwidth=540; $docheight=300;
 * 
 * A global object ($sysinfo) can be used to get information from the system in an OS independant manner
 */
 
include "sysinfo.php";

if (!isset($docwidth)) $docwidth=640;
if (!isset($docheight)) $docheight=480;
if (!isset($dur)) $dur=10;
if (!isset($reportName)) $reportName="device.xml";
if (!isset($info)) $info="Software modules";


echo "
<svg 
	xmlns='http://www.w3.org/2000/svg' 
	xmlns:xlink='http://www.w3.org/1999/xlink'
	width='100%' 
	height='100%' 
	viewBox='0 0 $docwidth $docheight'
	dur='$dur'>
	<defs
     id='defs47936'>
    <linearGradient
       id='linearGradient4695'>
      <stop
         style='stop-color:#ffffff;stop-opacity:0'
         offset='0'
         id='stop4696' />
      <stop
         style='stop-color:#ffffff;stop-opacity:1'
         offset='1'
         id='stop4697' />
    </linearGradient>
    <linearGradient
       x1='39.915527'
       y1='1191.6046'
       x2='39.915527'
       y2='1024.752'
       id='linearGradient47946'
       xlink:href='#linearGradient4695'
       gradientUnits='userSpaceOnUse'
       gradientTransform='matrix(0.3519232,0,0,5.6348685e-2,361.72796,354.67295)' />
    <linearGradient
       id='linearGradient8451'>
      <stop
         style='stop-color:#ffffff;stop-opacity:0'
         offset='0'
         id='stop8452' />
      <stop
         style='stop-color:#ffffff;stop-opacity:0.40555555'
         offset='1'
         id='stop8453' />
    </linearGradient>
    <linearGradient
       x1='97.852119'
       y1='1442.9766'
       x2='97.852119'
       y2='1560.7435'
       id='linearGradient47943'
       xlink:href='#linearGradient8451'
       gradientUnits='userSpaceOnUse'
       gradientTransform='matrix(0.3900454,0,0,5.0841277e-2,361.72796,364.67295)' />
  </defs>
";
  
function printNiceText($width, $height, $begin, $text, $icon, $color)
{
	$sx=$width/317.34439;
	$sy=$height/36.683365;
	$endflash=$begin+0.25;
	echo "
	<g transform='scale($sx $sy)' >
	  <g transform='translate(-292.75638,-411.16336)' >
	  	<rect width='317.34439' height='36.683365' rx='7.9786072' ry='10.279848' x='292.75638' y='411.16336'
	       style='fill:$color;fill-rule:nonzero;stroke:none;stroke-width:20.875;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:10.30000019;stroke-opacity:1' />
	   	<animation begin='$begin' x='305' y='414' width='33' height='33' preserveAspectRatio='xMinYMin' xlink:href='$icon'/>
	   	<text x='350' y='436' font-size='20' font-weight='bold' text-align='start' font-family='Trebuchet MS' fill='white'>$text</text>
	    <path
	       d='M 295.25695,422.1799 C 294.55277,420.65017 295.14746,417.81143 296.33391,415.91051 C 297.40678,414.43237 299.08899,412.95686 301.56667,412.69575 C 314.54519,412.678 589.86284,412.42298 602.84136,412.40523 C 604.02695,412.60464 605.68527,413.80876 606.85724,415.58379 C 607.3711,416.51305 607.81688,419.21446 607.13987,422.1799 C 590.79012,422.1799 311.6067,422.1799 295.25695,422.1799 z '
	       style='fill:url(#linearGradient47946);fill-rule:evenodd;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1' />
	    <path
	       d='M 293.83598,437.75211 C 294.30807,438.83742 295.62599,442.9345 296.74371,443.92414 C 297.60475,444.68651 299.94139,445.8857 300.66459,445.94772 L 601.62289,445.70465 C 602.62734,445.72015 604.85592,444.74478 606.4139,443.20184 C 608.41764,440.45096 608.53464,436.21717 608.62504,435.2869 C 608.17304,436.54276 602.45597,436.90074 602.75839,437.53032 L 298.05466,438.24212 C 296.64843,438.1646 294.91074,439.31806 293.83598,437.75211 z '
	       style='fill:url(#linearGradient47943);fill-rule:evenodd;stroke:none;stroke-width:1pt;stroke-linecap:butt;stroke-linejoin:miter;stroke-opacity:1' />
	  </g>
	  <rect transform='translate(-292.75638,-411.16336)' width='317.34439' height='36.683365' rx='7.9786072' ry='10.279848' x='292.75638' y='411.16336' fill='#ffffff' >
	  	<animate attributeName='fill-opacity' values='0;1;0' keyTimes='0;0.33;1' dur='0.25' begin='$begin'/>
	    <set attributeName='display' to='none' begin='$endflash'/>
	  </rect>
	</g>";
}
function to_readble_size($Bytes,$sufix="B")
{
  $Type=array("", "K", "M", "G", "T", "P", "E", "Z", "Y");
  $Index=0;
  while($Bytes>=1024)
  {
    $Bytes/=1024;
    $Index++;
  }
  $pre=0;
  if ($Bytes<100)
  	$pre++;
  if ($Bytes<10)
  	$pre++;
  $Bytes=round($Bytes,$pre);
  if ($sufix=="")
  	return($Bytes);
  else
  	return("".$Bytes." ".$Type[$Index].$sufix);
}

 function showInfos($docwidth, $docheight, $infos){

	// infos is a matrix containing for each line two column: the icon and the text.
 
	// Sizes of the button containing the icon and the text
 	$wtemp=317.34439;
 	$htemp=36.683365;

	$nbelem = count($infos);

	//Set the margin of the canvas on which the button will appear.	 	
 	$margin = 40; 	
 	$dh = $docheight-$margin; 	
 	$dw = $docwidth-$margin;
 	$lmargin=$margin/2;

	// compute the scaling factor so that the canvas will always occupy the maximum width and height
 	$h=$dw/$wtemp*$htemp;
 	$w=$dw;
 	if ($nbelem*$h>$dh){
 		$h=$dh/$nbelem;
 		$w=$wtemp/$htemp*$h;
 	}
 	
 	$bbh = $dh+$margin-$h;
 	$bbw = $w+$margin;
 	$bbstarty = $h;
 	//Display the canvas
 	print("<rect rx='$lmargin' ry='$lmargin' x='0' y='$bbstarty' height='$bbh' width='$bbw' stroke='#000000' stroke-width='2' fill='#364870' fill-opacity='1' stroke-linejoin='miter' stroke-miterlimit='4' id='HDMI_BCK'/>\n"); 	 	
 	$y=$lmargin; 	
 	$color[0] = '#de1d1d';
 	$color[1] = '#8eabe3';
 	$idx = 0;
 	$dur = 0.25;
 	$c=0;
 	foreach ($infos as $info) {
	  	print("<g transform='translate($lmargin, $y)' display='none'>\n");
	  	printNiceText($w, $h, $dur, $info[1], $info[0], $color[$c]);
	 	print("<set attributeName='display' to='inherit' begin='$dur'/>\n</g>\n");
	 	$y+=$h;
	 	$dur+=0.25;
	 	$c = 1;
 	}
 }
 
 
 function printText($text,$docwidth,$docheight){
 	$fonts=24;
 	global $dur;
 	
 	print("<textArea x='5' y='5' width='".($docwidth-10)."' height='".($docheight-10)."' fill='black' fill-opacity='1' font-family='Arial' font-size='${fonts}px'>\n");
	// the text itself"
	foreach ($text as $item){ 
		print("$item\n");
		print("<tbreak />");
	}
	if (isset($dur))
		print("<animate attributeName='fill-opacity' values='0;1;1;0' keyTimes='0;0.05;0.95;1' repeatDur='indefinite' dur='$dur'/>\n");
	print("</textArea>\n");
 }



 
 

 function printDefault($docwidth,$docheight,$info){
 	$infos = array(); 	
 	$infos[0]=array("sysinfo.svg",$info . " topic");
 	$infos[1]=array("sysinfo.svg","must be finalized yet!");
 	showInfos($docwidth, $docheight, $infos); 
 }
 function printDisplay($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$sysinfo= new sysinfo($reportName);
 	print("<!-- $reportName -->");
 	print("<!--");
 	print_r($sysinfo->info);
 	print("-->");
 	
 	if (!isset($noSave) || !$noSave){
 		print("<!-- Saved -->");
 		$sysinfo->genReport('display');
 		$sysinfo->saveReport($reportName); // update the values
 	}
 	 	
 	$infos = array();
 	$infos[]=array("sysinfo.svg",$info); 	
 	//$infos[]=array("status.svg",$sysinfo->info['display']['state']);
 	$infos[]=array('displayresolution.svg',$sysinfo->info['display']['displaywidth']." x ".$sysinfo->info['display']['displayheight']." px");
 	$infos[]=array('frequency.svg',$sysinfo->info['display']['frequency']." MHz");
 	$infos[]=array('docres.svg',$sysinfo->info['display']['renderwidth']." x ".$sysinfo->info['display']['renderheight']." px");
 	 	 	
 	
 	showInfos($docwidth, $docheight, $infos); 	
 }
 
  function printRendering($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$sysinfo= new sysinfo($reportName);
 	
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('status');
 		$sysinfo->saveReport($reportName); // update the values
 	}
 	 	
 	$infos = array();
 	$infos[]=array("displayresolution.svg","Rendering"); 	
 	//$infos[]=array("status.svg",$sysinfo->info['display']['state']);
 	$infos[]=array('docres.svg',$sysinfo->info['display']['renderwidth']." x ".$sysinfo->info['display']['renderheight']." px");
 	$infos[]=array('frequency.svg',$sysinfo->info['display']['renderfreq']." MHz");
 	$infos[]=array("sysinfo.svg","Up Time: ".$sysinfo->info['status']['uptime']);
 	//$infos[]=array("sysinfo.svg","Render Time: ".date("z \d\a\y G\hi\m", $sysinfo->info['player']['totalRenderTime_s']));
 	$infos[]=array("sysinfo.svg","Memory : ".$sysinfo->info['status']['memory']['used']." [".$sysinfo->info['status']['memory']['percent']."%]");
 	
 	showInfos($docwidth, $docheight, $infos); 	
 }
 
 function printDisk($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$sysinfo= new sysinfo($reportName);
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('disk');
 		$sysinfo->saveReport($reportName); // update the values
 	}
 	
 	$infos = array();
 	$infos[]=array("sysinfo.svg","Mass storage");
 	
	if (array_key_exists('serverPath', $sysinfo->info['disk'])){

		$servername = trim($sysinfo->info['disk']['serverPath'],"/");
		
		$pos = strrpos($servername,'/')+1;
		$servername = substr($servername,$pos);
		$infos[]=array("localdisk.svg","Local: " .$sysinfo->info['disk']['server']['free']. ' ['.$sysinfo->info['disk']['server']['percent'].'%]');
	}
	// should print USB and other disck also
	/*
	foreach ($sysinfo->info['disk']['mount'] as $disk){
		if ($disk['used']>0) $infos[]=array("localdisk.svg",$disk['name']." ".$disk['used']." [".$disk['percent']."%]");
	}
	*/
	showInfos($docwidth, $docheight, $infos);
}
 function printUSB($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	
 	$infos = array();
 	$infos[]=array("usb.svg",$info);
 	 	
 	$sysinfo= new sysinfo($reportName);
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('usb');
 		$sysinfo->saveReport($reportName); // update the values
 	}
 	$i = 0; 	
	foreach ($sysinfo->info['usb']['device'] as $usbname){
		$usb=$usbname['name'];
		$usb=preg_replace("/USB/i",'',$usb);
		if (!strpos($usb,"Hub") && !strpos($usb,"EHCI") && !strpos($usb,"UHCI") && !strpos($usb,"Composite") && strlen($usb)>1){ // do not print the hubs 
			$i++;
			if ($i<5) $infos[]=array("sysinfo.svg",$usb);
			if ($i==5) $infos[]=array("sysinfo.svg","...");
		}
	}
 	showInfos($docwidth, $docheight, $infos);
 }
 
  function printNetwork($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$infos = array();
 	$infos[]=array("network-wired.svg",$info);
 	
 	
 	$sysinfo= new sysinfo($reportName);
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('network');
 		$sysinfo->saveReport($reportName); // update the values
 	}
 	

 	$ip = $sysinfo->info['network']['ipaddress'];
 	$hn = $sysinfo->info['network']['hostname'];
	$infos[]=array("network-wired.svg", "IP: $ip" );
	$infos[]=array("network-wired.svg","Hostname: $hn");
	
	foreach ($sysinfo->info['network']['interface'] as $device){
		if ($device['tx']>0) $infos[]=array("hardware.svg", substr($device['name'],0,7) ." ". $device['tx']."/".$device['rx']);//." bw: ".$device['bandwidth']);
	}
	
	showInfos($docwidth, $docheight, $infos);
 }
 

 
 function printModules($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	
 	$sysinfo= new sysinfo($reportName);
 	print("<!-- $reportName -->");
 	print("<!--");
 	print_r($sysinfo->info);
 	print("-->");
 	$infos = array();
 	$infos[]=array("software.svg","Software modules");
 	if (isset($sysinfo->info['modules'])) 
		foreach ($sysinfo->info['modules']['module'] as $module)
			$infos[]=array("sysinfo.svg",$module);
	
 	showInfos($docwidth, $docheight, $infos);
 }
 
 function printVersion($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	
 	$sysinfo= new sysinfo($reportName);
 	print("<!-- $reportName -->");
 	print("<!--");
 	print_r($sysinfo->info);
 	print("-->");
 	
 	$infos = array();
 	$infos[]=array("software.svg","Versions");
 	if (isset($sysinfo->info['sysinfo']['filesystem'])) 
		$infos[]=array("sysinfo.svg","System: ".$sysinfo->info['sysinfo']['filesystem']['version']."-".$sysinfo->info['sysinfo']['filesystem']['build']);
	if (isset($sysinfo->info['sysinfo']['rpm'])) {
		$infos[]=array("sysinfo.svg","Player: ".$sysinfo->info['sysinfo']['rpm']['raperca']);
		$infos[]=array("sysinfo.svg","Cairo: ".$sysinfo->info['sysinfo']['rpm']['cairo']);
	}
	
 	showInfos($docwidth, $docheight, $infos);
 }
 
 
 function printHardware($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$infos = array();
 	$infos[]=array("hardware.svg","Hardware info");
 	
 	$sysinfo= new sysinfo($reportName);
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('sysinfo');
 		$sysinfo->saveReport($reportName); // update the values
 	}

 	$cpu = $sysinfo->info['sysinfo']['cpu']; 
 	$cpu = preg_replace("/Intel\(R\) Core\(TM\)(\d) CPU/",'Intel Core$1',$cpu); 	
 	$cpu = preg_replace("/@ (\d).(\d+)GHz/",'',$cpu);
 	
	$infos[]=array("sysinfo.svg",$cpu);
	if (isset($sysinfo->info['sysinfo']['cpuspeed']) && $sysinfo->info['sysinfo']['cpuspeed']!="")
		$infos[]=array("sysinfo.svg","Speed: ".$sysinfo->info['sysinfo']['cpuspeed']);
	$infos[]=array("sysinfo.svg","OS: ".$sysinfo->info['sysinfo']['platform']);
	if ($sysinfo->info['display']['name']!="unknown")
		$infos[]=array('hardware.svg',$sysinfo->info['display']['name']);
		
 	showInfos($docwidth, $docheight, $infos);
 }
 function printStatic($docwidth,$docheight,$info){
 	global $reportName;
 	global $noSave;
 	$infos = array();
 	
 	$sysinfo= new sysinfo($reportName);
 	if (!isset($noSave) || !$noSave){
 		$sysinfo->genReport('network');
 		$sysinfo->saveReport($reportName); // update the values
 	}
	$infos[]=array("network-wired.svg", $sysinfo->info['network']['hostname']);
 	$infos[]=array("network-wired.svg", $sysinfo->info['network']['ipaddress'] );
	$infos[]=array("sysinfo.svg",$sysinfo->info['sysinfo']['serial']);
		
 	showInfos($docwidth, $docheight, $infos);
 }
 
 if (isset($info)){

 	print("\n<!-- Info: $info -->\n");
 	switch ($info){
 		case "Rendering":				printRendering($docwidth,$docheight,$info); break;
 		case "Mass storage":			printDisk($docwidth,$docheight,$info); break;
 		case "USB devices":				printUSB($docwidth,$docheight,$info); break;
 		case "HDMI Display":			printDisplay($docwidth,$docheight,$info); break;
 		case "VGA Display":				printDisplay($docwidth,$docheight,$info); break;
 		case "SD cards":				printDefault($docwidth,$docheight,$info); break; 		
 		case "Wired network":			printNetwork($docwidth,$docheight,$info); break;
 		case "Hardware info":			printHardware($docwidth,$docheight,$info); break;
 		case "Software modules":		printModules($docwidth,$docheight,$info); break;
 		case "Local time":				printDefault($docwidth,$docheight,$info); break; 		
 		case "Device Info":				printStatic($docwidth,$docheight,$info); break;
 		case "Versions":				printVersion($docwidth,$docheight,$info); break;
 	}
 }
?>
</svg>
